
function fr_init_language() {
	var language = navigator.language || navigator.userLanguage;
	var lang = language.substring(0,2);
	fr.msg = fr_msg_en;
	$("#fr_bt_call").html(fr.msg.call);

}

var fr_msg_en = {
	answer: "answer",
	call: "call",
	cancel: "cancel",
	disconnect: "disconnect",
	directory: "directory",
	error_no_agent: "We are sorry there are no chat agents available right now, please try again later.",
	send: "send",
	clear: "clear",
	waiting: "waiting",
	welcome: "welcome",
	me: "me"
};

var fr_params = {
	did : null,
	pop : "us-east-nj",
	callerid : "anonymous",
	display_name : null,
	password : "nopassword",
	xheaders : [],
	debug : false,
	user_mic_muted : false,
	user_volume : 50
};

class Flowroute {
}

function fr_play_ring(){
	fr.sound_player.play();
}

function fr_stop_ring(){
	if(fr.sound_player === 'undefined'){return;}
	fr.sound_player.pause();
	if(fr.sound_player.currentTime != 0){fr.sound_player.currentTime = 0;}
}

function fr_jssip_ua_init(){
	fr.jssip_ua.on('registered', function(e){
		fr_wcons("registered");
		if(fr.registration == 1)
			return;
		fr.registration = 1;
		$("#fr_bt_call").unbind("click");
		$("#fr_bt_call").click(function() {fr_session_makecall()});
		fr_wcons('registered');

	fr.jssip_ua.on('newRTCSession', (data) => {
		fr_wcons('new RTC session');
		var display_name;
		var request = data.request;
		fr_qos.callid = request.call_id;
		fr_wcons("call-id:"+request.call_id);
		var session = data.session;
		fr.rtc_session = session;
		var uri = session.remote_identity.uri;

		display_name = session.remote_identity.display_name || session.remote_identity.uri.user;
		if (session.direction == 'incoming') {
			fr_wcons('incoming');
			if (fr.active_session) {fr_session_busy(session)}
			else {fr_session_incoming(session,request)}
		} else if (session.direction == 'outgoing'){
			fr_wcons('call: trying');
			fr_session_trying(session);
		}
		session.on('progress', () => {
			fr_wcons('call: progressing');
			fr_session_progress(this);
		});
		session.on('ended', () => {
			fr_audio_disconnect();
			fr_stop_ring();
			fr.active_session=0;
			fr_wcons('ended');
			$("#fr_bt_call").html(fr.msg.call);
			$("#fr_bt_call").unbind("click");
			$("#fr_bt_call").click(function() {fr_session_makecall()});
		});
		session.on('started', () => {
			fr_stop_ring();
			fr_session_established(e);
		});
		session.on('accepted', (data) => {
			fr_wcons('call: accepted');
			fr_stop_ring();

		});
		session.on('confirmed', (data) => {
			fr_wcons('call: confirmed');
			fr_session_established(data);
		});
		session.on('failed', (data) => {
			fr_stop_ring();
			fr_audio_disconnect();
		});
	});
	});
};

function fr_session_busy(rtc_session){
	var options = { status_code: 486, reason_phrase: 'Busy Here'};
	rtc_session.terminate(options);
	fr_wcons('busy');
}

function fr_session_answer(rtc_session) {
	fr_stop_ring();
	var options = {
		'mediaConstraints': {'audio': true, 'video': false},
		'extraHeaders': [ 'P-BUA:' + navigator.userAgent, 'P-REF:' + document.referrer],
		'RTCConstraints': {"optional": [{'DtlsSrtpKeyAgreement': 'true'}]}
	};
	rtc_session.answer(options);
	$("#fr_bt_call").html(fr.msg.disconnect);
	$("#fr_bt_call").unbind("click");
	$("#fr_bt_call").click(function(e) {fr_session_disconnect(rtc_session)});
}

function fr_session_incoming(rtc_session,request) {
	fr_play_ring();

	if ($("#fr_target_user").length) {
		$("#fr_target_user").html(request.from.uri.user);
	}

	$("#fr_bt_call").html(fr.msg.answer);
	$("#fr_bt_call").unbind("click");
	$("#fr_bt_call").click(function(e) {fr_session_answer(rtc_session)});
}
